/* ECE271 Spring 2019 Lab1 -- Linux version */

#include <stdint.h>

#include "stm32l.h"

// ORIGIN = 0x20000000, LENGTH = 96K
#define STACK_LOCATION (0x20000000+(96*1024))

void System_Clock_Init(void) {

	/* Reset the RCC clock to the default reset state */
	/* Set MSION bit */
	RCC->CR |= RCC_CR_MSION;

	/* Reset CFGR register */
	RCC->CFGR = 0x00000000U;

	/* Reset HSEON, CSSON , HSION, and PLLON bits */
	RCC->CR &= 0xEAF6FFFFU;

	/* Reset PLLCFGR register */
	RCC->PLLCFGR = 0x00001000U;

	/* Reset HSEBYP bit */
	RCC->CR &= ~(RCC_CR_HSEBYP);

	/* Disable all interrupts */
	RCC->CIER = 0x00000000U;
}


int main(void) {

	System_Clock_Init();

	/* Your Code Here */

	return 0;
}

/* Don't mess with the code below unless you know what you are doing */

void Reset_Handler(void) {
	main();
}

static void default_handler(void) {
	while(1);
}


/* Vector Table */
uint32_t *myvectors[128]
__attribute__ ((section(".isr_vector"))) = {
        (uint32_t *) STACK_LOCATION,	/* stack pointer      */
        (uint32_t *) Reset_Handler,	/* code entry point   */
        (uint32_t *) default_handler,	/* NMI handler        */
        (uint32_t *) default_handler,	/* hard fault handler */
};

